#include "WString.h"
class Button {
private:
  bool enabledLongPress;
  uint8_t mask;
  uint8_t *reg;
  long lastUpTime;
  long lastDownTime;

  bool shortPress;
  bool longPress;
  bool lastValue;

  bool longPressActivated = false;

  int repeatState = 0;
  int lastRepeatTime = 0;

public:
  Button(bool enabledLongPress, uint8_t mask, uint8_t * reg) {
    this->enabledLongPress = enabledLongPress;
    this->mask = mask;
    this->reg = reg;
  }

  void update() {
    shortPress = false;
    longPress = false;
    bool val = (*reg) & mask;
    long time = millis();
    if (val != lastValue) {
      lastValue = val;
      if (!val) {
        if (time - lastDownTime > 150) {
          if (!enabledLongPress) {
            shortPress = true;
            repeatState = 1;
          }
        }
        lastDownTime = time;
      } else {
        if (time - lastUpTime > 150) {
          if (enabledLongPress) {
            if (time - lastDownTime < 400) {
              shortPress = true;
            } else {
              longPressActivated = false;
            }
          } else {
            repeatState = 0;
          }
        }
        lastUpTime = time;
      }
    } else {
      if (!val && time - lastDownTime > 400 && enabledLongPress && !longPressActivated) {
        longPress = true;
        longPressActivated = true;
      }

      if (val) repeatState = 0;

      if (!enabledLongPress && repeatState >= 1) {
        if (repeatState == 1 && time - lastDownTime >= 1000) {
          repeatState++;
          lastRepeatTime = -1;
        }
        if (repeatState >= 2) {
          if (time - lastRepeatTime >= 100) {
            lastRepeatTime = time;
            shortPress = true;
          }
        }
      }
    }
  }
        

    bool isShortPress() {
      return shortPress;
    }

    bool isLongPress() {
      return longPress;
    }
};
